<?php

class GptMasterRssFeed {
    public function __construct($feedObject,$category) {
        $properties = get_object_vars($feedObject);

        foreach ($properties as $name => $value) {
            $this->$name = $value;
        }   
        if (empty($this->thumb)) $this->thumb = $this->getThumb('url');
        $this->category = $category;
        return $this;
    }    
    
    public function getThumb($format='image') {
        if (!empty($this->thumb)) return $this->thumb;
        $thumb = false;
        if (isset($this->enclosure)) {
            $thumb = is_object($this->enclosure)?(string)$this->enclosure['url'] : $this->enclosure;
        } elseif (isset($this->thumbnail)) {
            $thumb = is_object($this->thumbnail)?(string)$this->thumbnail['url'] : $this->thumbnail;
        } elseif(isset($this->thumb)) {
            $thumb = is_object($this->thumb)?(string)$this->thumb['url'] : $this->thumb;
        } elseif(isset($this->image)) {
            $thumb = is_object($this->image)?(string)$this->image['url'] : $this->image;
        } elseif(isset($this->content)) {
            $pattern = '/<img.*?src=["\'](.*?)["\'].*?>/i';
            $matches = [];
            if (preg_match($pattern, $this->content, $matches)) {
                $thumb = $matches[1];            
            }    
        } elseif(isset($this->description)) {
            $pattern = '/<img.*?src=["\'](.*?)["\'].*?>/i';
            $matches = [];
            if (preg_match($pattern, $this->description, $matches)) {
                $thumb = $matches[1];            
            }    
        }
        $result = false;
        switch ($format) {
            case 'image': {
                $result = (empty($thumb)) ? '' : '<img class="gm-rss-thumb" src="'.$thumb.'"/>';
            } break;
            case 'url': 
            default : {
                $result = $thumb;
            }
        }
        return $result;
    }
    
    public function getDescription() {
        return (empty($this->description))?'':strip_tags($this->description);
    }
    
    public function getContent() {
        return (empty($this->content))?'':strip_tags($this->content);
    }
    /*
    public function getContent() {
        $content = empty($this->content) ? $this->description : $this->content;
        return $content;
    }*/
    
    public function getLink($targetBlank=true) {
        return '<a href="'.$this->url.'"'.($targetBlank?' target="_blank">':'>').$this->title.'</a>';
    }    
    
    public function getDate($format='Y.m.d H:i:s') {
        if ($format == false) return $this->timestamp;
        return date($format,$this->timestamp);
    }
}

class GptMasterRssFeeds {
        
    public static function loadChannel($url,$category) {
        $feedObjects = GptMasterRssReader::load($url);
     
        if ($feedObjects) {
            $gmFeeds = [];
            foreach($feedObjects->item as $feedObject) {
                $gmFeeds[] = new GptMasterRssFeed($feedObject,$category);
            }
            
            return $gmFeeds;
        }
        return false;
    }

    public static function loadChannelsList($channelsList) {
        $gmFeeds = [];        
        foreach($channelsList as $ind=>$channel) {
            $channelData = self::loadChannel(trim($channel['url']),trim($channel['category']));
     
            if (is_array($channelData)) {
                $gmFeeds = array_merge($gmFeeds,$channelData);
            }
        }
        return $gmFeeds;
    }

}
