function multifield_value_refresh($ob) {
	$list = $ob.closest('.gpt-master-multifield-list');
	$rows = $list.find('.gpt-master-multifield-row');
	var multifield_data = [];
	$rows.each(function() {		
		$inputs = jQuery(this).find('input');
		if ($inputs.length > 1) {
			multifield_row = {};
			$inputs.each(function(){
				multifield_row[jQuery(this).data('key')] = jQuery(this).val();
			});			
		} else if($inputs.length === 1) {
			multifield_row = $inputs.val();				
		}

		multifield_data.push(multifield_row);
	});
	$list.next('input').val(JSON.stringify(multifield_data));
}

jQuery(function(){
	jQuery('#taskTable').DataTable({
		order: [[0, 'asc']],
		language: {
			url: '//cdn.datatables.net/plug-ins/1.13.4/i18n/ru.json',
		},		
		"pageLength": 100,
		"lengthChange": false,
		"bPaginate": true,
		"bFilter": false
	});
	
	jQuery('.gpt-master-form-row[data-chain_field]').each(function(){
		jQuery('[name="'+jQuery(this).data('chain_field')+'"]').on('change',function(){
			key = jQuery(this).attr('name');
			value = jQuery(this).val();
			jQuery('.gpt-master-form-row[data-chain_field="'+key+'"]').hide();
			jQuery('.gpt-master-form-row[data-chain_field="'+key+'"][data-chain_value="'+value+'"]').show();
		});
	});
	
	jQuery('body').on('click','a[data-action]',function(){
		jQuery(this).prop('disabled',true);
		data = jQuery(this).data('action');
		
		switch(data.action) {
			case 'task_moderate': {
				isModeration = jQuery(this).find('i').hasClass('fa-eye-slash');
				data.task_status = isModeration ? 1 : 0;
			} break;
		}	
		
		console.log(data);
		jQuery.ajax({
			url : '/wp-admin/admin-ajax.php',
			data : data,
			dataType : 'json',
			contents : this
		}).done(function(response){
			data = jQuery(this.contents).data('action');
			if (response.result === 'OK') {
				switch(data.action) {
					case 'task_remove': {
						jQuery(this.contents).closest('tr').remove();	
					} break;
					case 'task_moderate': {
						isModeration = jQuery(this.contents).find('i').hasClass('fa-eye-slash');
						if (isModeration) {
							jQuery(this.contents).find('i').removeClass('fa-eye-slash').addClass('fa-eye');
							jQuery(this.contents).attr('title','Исключить из задач');
							jQuery(this.contents).closest('td').prev().find('b').text('ожидается');
						} else {
							jQuery(this.contents).find('i').removeClass('fa-eye').addClass('fa-eye-slash');
							jQuery(this.contents).attr('title','Одобрить в работу');				
							jQuery(this.contents).closest('td').prev().find('b').text('на модерации');
						}
						
					} break;
					case 'task_redo': {
						jQuery(this.contents).closest('td').prev().find('b').text('ожидается');
					} break;
				}
			}
			jQuery(this.contents).removeProp('disabled');
		}).fail(function(){
			jQuery(this.contents).removeProp('disabled');
		});
		return false;
	}).on('click','.gpt-master-multifield-add',function(){
		$this = jQuery(this);
		classPrefix = 'gpt-master-multifield-';
		$dashboard = $this.closest('.'+classPrefix+'dashboard');
		$newRow = $dashboard.clone();
		$newRow.removeClass(classPrefix+'dashboard').addClass(classPrefix+'row');
		$newRow.find('.'+classPrefix+'add').removeClass(classPrefix+'add button-primary').addClass(classPrefix+'remove').find('.fa-plus').removeClass('fa-plus').addClass('fa-trash');
		$newRow.insertBefore($dashboard);
		$dashboard.find('input').each(function(){
			jQuery(this).val('');
		});
		multifield_value_refresh($this);
		return false;
	}).on('click','.gpt-master-multifield-remove',function(){
		$this = jQuery(this);
		$list = $this.closest('.gpt-master-multifield-list');
		$this.closest('.gpt-master-multifield-row').remove();
		multifield_value_refresh($list);
		return false;
	}).on('change','.gpt-master-multifield-row input',function(){
		multifield_value_refresh(jQuery(this));
	});
});

